const express = require('express');
const jwt = require('jsonwebtoken');
const admin_users = express();
// Middleware for parsing JSON
admin_users.use(express.json());
//DB configure-connection
const connection = require('../config');


// Middleware to parse JSON requests
admin_users.use(express.json());

  

admin_users.post('/login', (req, res) => {
  const { username, password } = req.body;

  // Check if the username exists in the database
  connection.query('SELECT * FROM admin_users WHERE username = ?', [username], (error, results) => {
    if (error) {
      console.error(error);
      res.sendStatus(500);
    } else {
      if (results.length > 0) {
        const user = results[0];
        const storedPassword = user.password; // Assuming the plaintext password is stored in a column called 'password'

        // Compare the provided password with the password from the database
        if (password === storedPassword) {
          // Passwords match, get the OTP code and generate a JWT token
          const token = jwt.sign({ userId: user.id }, 'your_secret_key');
          const otp_code = user.otp_code; // Retrieve the otp_code from the user record
          res.status(200).json({ token, otp_code });
        } else {
          // Password doesn't match
          res.sendStatus(401);
        }
      } else {
        // Username not found in the database
        res.sendStatus(401);
      }
    }
  });
});


// GET all user method

admin_users.get('/getuser', (req, res) => {
  const query = 'SELECT * FROM admin_users';

  connection.query(query, (err, results) => {
    if (err) {
      console.error('Error executing MySQL query: ', err);
      res.sendStatus(500);
      return;
    }

    if (results.length === 0) {
      res.sendStatus(404);
      return;
    }

    res.json(results);
  });
});


// POST method
admin_users.post('/add/post', (req, res) => {
  //testing
  const { username, password } = req.body;
  const query = 'INSERT INTO admin_users ( username, password ) VALUES (?, ?)';

  connection.query(query, [username, password], (err, results) => {
    if (err) {
      console.error('Error executing MySQL query: ' + err.stack);
      res.status(500).json({ error: 'Failed to create user' });
      return;
    }

    res.json({ message: 'User created successfully' });
  });
});


admin_users.put('/put/:id', (req, res) => {
  const Id = req.params.id;
  const updatedData = req.body;

  const query = 'UPDATE admin_users SET ? WHERE id = ?';
  connection.query(query, [updatedData, Id], (error, results) => {
    if (error) {
      console.error('Error executing query:', error);
      res.status(500).json({ error: 'Error executing query' });
    } else {
      if (results.affectedRows > 0) {
        res.json({ message: 'Data updated successfully' });
      } else {
        res.status(404).json({ error: 'Book not found' });
      }
    }
  });
});


admin_users.delete('/del/:id', (req, res) => {
  const Id = req.params.id;

  const query = 'DELETE FROM admin_users WHERE id = ?';
  connection.query(query, [Id], (error, results) => {
    if (error) {
      console.error('Error executing query:', error);
      res.status(500).json({ error: 'Error executing query' });
    } else {
      if (results.affectedRows > 0) {
        res.json({ message: 'Book deleted successfully' });
      } else {
        res.status(404).json({ error: 'Book not found' });
      }
    }
  });
});


// Create a login API endpoint
admin_users.post('/login', (req, res) => {
    const { username, password } = req.body;
  
    if (!username || !password) {
      return res.status(400).json({ message: 'username and password are required' });
    }
  
    // Find user with given username in database
    connection.query('SELECT * FROM admin_users WHERE username = ?', [username], (error, results) => {
      if (error) {
        console.error(error);
        return res.status(500).json({ message: 'Internal server error' });
      }
  
      if (results.length === 0) {
        return res.status(401).json({ message: 'Invalid username or password' });
      }
  
      const user = results[0];
  
      if (user.password !== password) {
        return res.status(401).json({ message: 'Invalid username or password' });
      }

      if (user.username===username && user.password===password){
        return res.status(200).json({ message:"ok"})
      }
  
  //     // Generate JWT token and return to client
  //     const token = jwt.sign({ userId: user.id }, 'your_jwt_secret');
  //     res.json({ token });
  });
  });



  module.exports = admin_users;